--set bullet speed
bullet_speed = 1600
--generic variable that demonstrates the current direction of the player. "right" is just a temporary value that will change once the player presses a directional key
cur_dir = "right"
--setup bullet table
bullet = {}

function bulletSpawn(x,y,dir)
	--spawn a bullet/insert a new bullet into the bullet table
	table.insert(bullet, {width = 10, height = 10, x = x, y = y, dir = dir, alive = true})
end

function bulletUpdate(dt)
	--bullet update loop
	for i,v in ipairs(bullet) do
		--if the current bullet in the loop is still alive...
		if (v.alive == true) then
			--determines bullet's direction, then moves it that way
			if v.dir == "right" then
				v.x = v.x + bullet_speed * dt
			end
			if v.dir == "left" then
				v.x = v.x - bullet_speed * dt
			end
			if v.dir == "down" then
				v.y = v.y + bullet_speed * dt
			end
			if v.dir == "up" then
				v.y = v.y - bullet_speed * dt
			end
		end
	end
end

function bulletDraw()
	for i,v in ipairs(bullet) do
		--if the current bullet in the loop is still alive...
		if (v.alive == true) then
			--draw bullet
			love.graphics.setColor(255,255,255)
			love.graphics.rectangle('fill',v.x,v.y,v.width,v.height)
		end
	end
end

function bulletShoot(key)
	--checks which key was pressed (well, which key was sent to the function), then, if a directional key was pressed, sets the cur_dir variable to the approriate direction
	if key == "right" then
		cur_dir = "right"
	end
	if key == "left" then
		cur_dir = "left"
	end
	if key == "down" then
		cur_dir = "down"
	end
	if key == "up" then
		cur_dir = "up"
	end
	--shoot a bullet
	if key == "x" then
		bulletSpawn(playerX - 5, playerY - 5, cur_dir)
	end
end