--set generic enemy speed
enemy_speed = 200;
--setup enemy table
enemy = {}

function enemySpawn(x,y,DesX,DesY)	
	--spawn an enemy

	--set local variables for spawning purposes (part 1)
	local pDexX = DesX
	local pDexY = DesY
	--check if DesX and/or DesY are set
	if (pDexX == nil) then pDexX = x end
	if (pDexY == nil) then pDexY = y end
	--set local variables for spawning purposes (part 2)
	local pAn = math.atan2((pDexY - y),(pDexX - x))
	local pDX = enemy_speed * math.cos(pAn)
	local pDY = enemy_speed * math.sin(pAn)
	--spawn an enemy/insert a new enemy into the enemy table
	table.insert(enemy, 
	{width = 40, 
	height = 40, 
	color = {255,255,255,255}, 
	x = x, 
	y = y, 
	alive = true,
	--the rest of these variables here have to do with the simple "move towards point" code
	pathStartX = x, 
	pathStartY = y,
	pathDesX = pDexX,
	pathDesY = pDexY,
	pathAngle = pAn,
	pathDX = pDX,
	pathDY = pDY})
end

function enemyUpdate(dt)
	for i,v in ipairs(enemy) do
		--if the current enemy in the loop is still alive...
		if (v.alive == true) then
			--if the current enemy in the loop is less than 501 pixels away from the player...
			if (checkDistance(v.x + (v.width/2), v.y + (v.height/2), playerX, playerY) <= 500) then
				--change draw color to red (for testing purposes)
				v.color = {255,0,0,255}
				--move towards point/player code
				v.pathStartX = v.x
				v.pathStartY = v.y
				v.pathDesX = playerX
				v.pathDesY = playerY
				v.pathAngle = math.atan2((v.pathDesY - v.pathStartY),(v.pathDesX - v.pathStartX))
				v.pathDX = enemy_speed * math.cos(v.pathAngle)
				v.pathDY = enemy_speed * math.sin(v.pathAngle)
			else
				--set draw color back to white
				v.color = {255,255,255,255}
			end
			
			--if the current enemy in the loop is more than 10 pixels away from its destination (determined by pathDesX and pathDesY)
			if (checkDistance(v.x, v.y, v.pathDesX, v.pathDesY) >= 11) then
				--move towards destination
				v.x = v.x + (v.pathDX * dt)
				v.y = v.y + (v.pathDY * dt)	
			end
	
			--a loop to run through the bullets and check for collisions qwith the current enemy in the loop
			for o,b in ipairs(bullet) do
				--if the current bullet in the loop is still alive...
				if (b.alive == true) then
					--if the current bulleti n the loop collides with the current enemy in the loop...
					if (checkBoxCollision(v.x,v.y,v.width,v.height,b.x,b.y,b.width,b.height) == true) then
						--kill current enemy in the loop
						v.alive = false
						--kill current bullet in the loop
						b.alive = false
						--run "enemy died" function
						enemyDied()
					end
				end
			end
		end
	end
end

function enemyDraw()
	for i,v in ipairs(enemy) do
		--if the current enemy in the loop is still alive...
		if (v.alive == true) then
			--draw current enemy
			love.graphics.setColor(v.color)
			love.graphics.rectangle('fill',v.x,v.y,v.width,v.height)
		end
	end
end

function enemyDied()
	--function that is triggered whenever an enemy dies. Currently only for testing purposes.
	--spawn an enemy at a random x position
	enemySpawn(math.random(1280),64,playerX,playerY)
end