require "gameWorld"
require "player"
require "bullet"
require "enemy"

function love.load()
	--set background color
	love.graphics.setBackgroundColor(104, 136, 248)
	--set window dimensions
	love.graphics.setMode(1280, 1024, false, true, 0)
	--initialize game world
	gameWorldInit()
	
end

function love.update(dt)
	--update game world
	gameWorldUpdate(dt)
end

function love.draw()
	--draw game world
	gameWorldDraw()
	--draw FPS
	love.graphics.setColor(255, 255, 255)
	love.graphics.print("Current FPS: "..tostring(love.timer.getFPS( )), 5, 5)
end

function checkDistance(x1, y1, x2, y2)
    --basic function to check distance between one position and another
	local dx = x2 - x1
    local dy = y2 - y1
    local dist = math.sqrt((dx * dx) + (dy * dy))
    return dist
end

function checkBoxCollision(ax1,ay1,aw,ah,bx1,by1,bw,bh)
  --basic bounding box collision function
  --ax1 = box a's x, ay1 = box a's y, aw = box a's width, ah = box a's height
  --bx1 = box b's x, by1 = box b's y, bw = box b's width, bh = box b's height
  local ax2,ay2,bx2,by2 = ax1 + aw, ay1 + ah, bx1 + bw, by1 + bh
  return ax1 < bx2 and ax2 > bx1 and ay1 < by2 and ay2 > by1
end

function quitGame(key)
	--basic function for quiting game
	if (key == "escape") then
		love.event.push('quit')
	end
end