function playerInit(x, y)
	--set player start position (as well as define the playerX and playerY variables)
	playerX = x
	playerY = y
	--setup player table
	objects.player = {}
	--setup player's physics body
	objects.player.body = love.physics.newBody(world, playerX, playerY, "dynamic")
	--setup player's shape
	objects.player.shape = love.physics.newCircleShape(20)
	--setup player's fixture
	objects.player.fixture = love.physics.newFixture(objects.player.body, objects.player.shape, 1)
	--make the player bounce a little bit
	objects.player.fixture:setRestitution(0.2)
end

function playerUpdate(dt)
	--left/right movement
	if love.keyboard.isDown("right") then 
		objects.player.body:applyForce(400, 0)
	elseif love.keyboard.isDown("left") then 
		objects.player.body:applyForce(-400, 0)
	end
	--"jumping"
	if love.keyboard.isDown("z") then
		objects.player.body:applyForce(0, -400)
	end
	--update playerX and playerY variables - these are used by many other entities, so it's important to keep this updated
	playerX = objects.player.body:getX()
	playerY = objects.player.body:getY()
end

function playerDraw()
	--draw player
	love.graphics.setColor(193, 47, 14)
	love.graphics.circle("fill", playerX, playerY, objects.player.shape:getRadius())
end